//+------------------------------------------------------------------+
//|                                           MA Martingale v2.2.mq4 |
//|                                                    Ramiro Alonso |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Ramiro Alonso - Version 2.2"
#property link      "www.forexfactory.com/forum"

#include <stdlib.mqh>
#include <stderror.mqh> //Handles errors.
#include <info.mq4> //Handles informatin displayed on chart.

#include <AllOrdersControl.mq4> //Place in memory the array containing orders ejecuted by EA.
                              //It makes faster and secure ejecution of this EA.
extern int Magic = 9999;//Number used by EA to identify orders placed by itself and manage them.

extern int TakeProfit=30; //Fixed pips profit target on each order.
extern int PipsStep=25; //Fixed pip loss until a new order is entered in the same way.

extern int MaxTrades = 9; //Max number of orders in a martingale (group of related orders).

extern string EmergencyClose_desc="Order number to close martingale at break even";
extern int EmergencyClose = 9; //Order number to close martingale at break even.
extern bool TrailingProfit=false;

extern double FactorLot = 2; //Multiplier of previous lotsize. This is the lot size growth factor of the next order.
extern double FactorPips = 1;//Multiplier of previos PipsStep. This is the pip loss growth factor of the next order.
extern int OrdenSalto = 5;//Number of order to make a jump (Salto) on the FactorLot. It could be negative also (fall).
extern double Salto = 1;//Determine size jump on growth of the lot size.


extern bool mm=true; //If it is "true" EA manage money management as percentage of balance.
extern bool MiniAccount=true; //If EA work on a mini or standar.

extern string ReversCondition_desc="Read inverse the indicator signals. If buy, then sell and viceversa";
extern bool ReverseCondition=false; //Read inverse the indicator signals. If buy, then sell and viceversa.
extern double risk=0.15; //Lot size of initial trade as percentage of balance
extern double InitialFixedLots=0.01; //Minimum lot size admitted by broker/trader.
extern double MaxLots=50;//Maximum lot size admitted by broker/trader.

extern string MAMethod_desc="0-Simple/ 1-Exponential/ 2-Smoothed/ 3-Weighted";
extern int MAMethod = MODE_SMMA; //Method of Moving Average Indicator.
extern int MAPeriod = 100;//Period of Moving Average Indicator.
extern string MAPrice_desc="0-Close/ 1-Open/ 2-High/ 3-Low/ 4-8 Others";
extern int MAPrice = MODE_OPEN; //Prices of Moving Avergae Indicator.

extern string StopTrading_desc="Stops trading when all opened orders get closed";
extern bool StopTrading = false; //Stops trading if there isn't open orders.

extern int slippage = 40;//Slippage for close orders.

extern string ForceOrderType_desc="Force open trade. 1-Buy/ 2-Sell /6-None";
extern int ForceOrderType = 6;

extern string UpdateVar_Desc="Trader set values when EA lose them by restart";
extern bool UpdateVar = false;
extern double NewLastLotSize = 0;
extern int NewMaxTradesAux = 0;
extern int NewPreviousOpenOrders = 0;

int myOrderType = 6, leverage=0;
int cnt, cnt2, NumberOfTries = 5, error;
double lotsi=0, myLotAux, tp, sl, BuyPrice, SellPrice,SaltoAux;
double PipsStepAux;
string text = "";
bool ContinueOpening=true;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   info_init();
   
   info( 0, "Renglon 1 de prueba" );
	info( 1, "Renglon 2 color rojo", Red );
	info( 2, "Renglon 3 negro :)", Black );
	info( 3, "Renglon 4 negro espacio = 11", Black, 11 );
	Sleep(1000);
	return(0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

   info_deinit();
	return(0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //Static variable called LastLotSize is stored in the permanent memory for retrieve this
   //information on reloaded of EA (i.e. after a shut down of computer).
   static double LastLotSize = 0;
   static int MaxTradesAux = 0;
   static int PreviousOpenOrders = 0;
   
   //Identifica las ordenes abiertas por el EA y las carga en una matriz para manejarlas
   //mas rpido y unvoco.
   AllOrdersInit(Magic);
   
   //Esta condicion es necesaria para resetear el valor de PreviousOpenOrders cuando se cierra
   //todo, y no antes de cerrar todo.
   if(_ExpertOrdersTotal<1)
   {
      if(StopTrading==true)
      {
         Comment("EA BLOQUEADO POR EL USUARIO.");
         return;
      }
      else
      {
          PreviousOpenOrders = _ExpertOrdersTotal;
          MaxTradesAux = 0;
          LastLotSize = 0;
      }
   }
   
    if(UpdateVar==true)
   {
      LastLotSize = NewLastLotSize;
      MaxTradesAux = NewMaxTradesAux;
      PreviousOpenOrders = NewPreviousOpenOrders;
   }

   
   //Si una orden toc su TP, entonces cierra las dems de la serie.
   if (PreviousOpenOrders>_ExpertOrdersTotal) 
   {	
      //Aseguro que no ingrese nuevas ordenes.
      ContinueOpening=False;
      //Busca asegurarse que se hayan cerrado todas las ordenes. En fowartest ocurri que una
      //orden intermedia qued sin cerrar por un problema momentneo de conexin.
      //De esta manera el EA cierra todo y luego revisa si efectivamente cerr todo.  
      CierraTodo();
      MaxTradesAux = 0;
      //Este return es necesario para que no reasigne el valor de PreviousOpenOrders cuando no
      //se cerraron juntas todas las ordenes de una misma martingala.
      return;
   }
   
   //Evalua si se abrieron el maximo de ordenes admitidas, y permite o no abrir nuevas si
   //fuera necesario.
   PreviousOpenOrders=_ExpertOrdersTotal;
   if (_ExpertOrdersTotal>=(MaxTrades+MaxTradesAux)) 
   {
	  ContinueOpening=False;
   } else {
	  ContinueOpening=True;
   }
   
   //Cierra todo si la martingala alcanza un valor mayor o igual a cero a partir de EmergencyClose.
   if(_ExpertProfitTotal>=0 &&
   _ExpertOrdersTotal>=(EmergencyClose+MaxTradesAux))
   {
   CierraTodo();
   MaxTradesAux = 0;
   }
   
   //Si no hay ninguna orden abierta evalua los indicadores tcnicos para ver si se presenta
   //una seal de entrada. 
   if (_ExpertOrdersTotal<1) 
   {
     myOrderType=6;
	  
	  //Identifica una seal de COMPRA = BUY. 
	  if(iLow(0,0,1)>iMA(0,0,MAPeriod,0,MAMethod,MAPrice,1) &&
	  iLow(0,0,2)>iMA(0,0,MAPeriod,0,MAMethod,MAPrice,2) &&
	  iLow(0,0,3)<iMA(0,0,MAPeriod,0,MAMethod,MAPrice,3) &&
	  iLow(0,0,4)<iMA(0,0,MAPeriod,0,MAMethod,MAPrice,4) &&
	  iOpen(0,0,0)>iMA(0,0,MAPeriod,0,MAMethod,PRICE_HIGH,0)) { myOrderType=0; }
	  
	  
	  //Identifica una seal de VENTA = SELL.
	  if(iHigh(0,0,1)<iMA(0,0,MAPeriod,0,MAMethod,MAPrice,1) &&
	  iHigh(0,0,2)<iMA(0,0,MAPeriod,0,MAMethod,MAPrice,2) &&
	  iHigh(0,0,3)>iMA(0,0,MAPeriod,0,MAMethod,MAPrice,3) &&
	  iHigh(0,0,4)>iMA(0,0,MAPeriod,0,MAMethod,MAPrice,4) &&
	  iOpen(0,0,0)<iMA(0,0,MAPeriod,0,MAMethod,PRICE_LOW,0)) { myOrderType=1; }
	  
	  //Force enter a new trade.
	  if(ForceOrderType==0 || ForceOrderType==1) { myOrderType=ForceOrderType; }
	  	  
	  //Invierte la ejecucin de la seal. Si seal Buy, entoces Sell y viceversa.
	  if (ReverseCondition==true)
	  {
	  	  if (myOrderType==0) { myOrderType=1; }
		  else { if (myOrderType==1) { myOrderType=0; } }
	  }	 
	}

	//When opened orders is equal to "OrdenSalto", a jump/fall on the lot size growth
   //in next order will increase/decrease equal to "Salto".
   if(_ExpertOrdersTotal==(OrdenSalto+MaxTradesAux-1))SaltoAux=Salto;
   else SaltoAux = 1;
        
   //Determine lot size in first order only.
   if(mm==true && _ExpertOrdersTotal<1)
   {
      if (MiniAccount==false) {leverage=1000;}
      else { leverage=10000;}
      
      //Determine lot size as % of balance.
      lotsi=NormalizeDouble(AccountBalance()*risk/leverage,2);
   }
   
   //Used when initial lot size is fixed.
   if(mm!=true && _ExpertOrdersTotal<1)
   {
      lotsi=InitialFixedLots;
   }
      
   //Si ya hay ordenes abiertas determina el tamao del lote en funcin de la ltima
   //orden abierta en la serie.
   if(_ExpertOrdersTotal>0)
   {
      //Si se reinici el EA y no se almacen el mayor tamao de lote.
      //Si bien LastLotSize es una variable static que no se pierde al cerrar el EA
      //aseguro el valor de LastLotSize con _ExpertBiggerLot porque de lo contrario
      //no se van a ingresar las ordenes siguientes necesarias de la martingala.
      //Este valor puede ser errneo si LastLotSize > 50. _ExpertBiggerLot ser igual 50.
      if(LastLotSize<=0) {LastLotSize = _ExpertBiggerLot;}
      
      lotsi=NormalizeDouble(LastLotSize*FactorLot*SaltoAux,2);
   }
   
   //Asegura que el tamao del lote sea igual o mayor al InitialFixedLots.
   if(lotsi<=InitialFixedLots) { lotsi=InitialFixedLots; }
   
   //Determina el aumento en la diferencia de pips entre una orden y otra de la martingala.
   PipsStepAux=PipsStep;
   if(_ExpertOrdersTotal>0)
   {
     PipsStepAux=NormalizeDouble(PipsStep*MathPow((1+FactorPips/100),_ExpertOrdersTotal-1),0);  
   }
   
   //Si no hay margen no hace nada.
   if(AccountFreeMarginCheck(Symbol(),myOrderType,lotsi)<=0 && ContinueOpening==true &&
   _ExpertOrdersTotal>0)
   {
       text = "Free Margin :"+DoubleToStr(AccountFreeMargin(),2)+
       " Margen insuficiente para prxima orden." ;
       info( 4, text, Red );
       return(0);
   }  
   
               
   //Se informa en observaciones de ordenes pendientes el MagicNumber del EA y el nmero de
   //orden de la serie de la martingala.
   text="Magic: "+DoubleToStr(Magic,0)+". Orden: "+(_ExpertOrdersTotal-MaxTradesAux+1)+" de "+MaxTrades;
   
   //Abre ordenes si se dieron las condiciones de los indicadores si hay margen en la cuenta.
   if(ContinueOpening==true)
   {
      switch(myOrderType)
      {
         //BUY
         case 0:
            //Si no hay ordenes abiertas o la ltima pierde PipsStep
            if(_ExpertOrdersTotal<1 ||(_OrderOpenPrice[0]-Ask)>=PipsStepAux*Point)
            {
               
               BuyPrice=NormalizeDouble(Ask,Digits);
               if(_ExpertOrdersTotal>0) tp=_OrderOpenPrice[0]+(TakeProfit-PipsStep)*Point;
               else tp = Ask+TakeProfit*Point;
               sl = 0;
         
               myLotAux = NormalizeDouble(MathMod(lotsi,MaxLots),2);
         
               if(myLotAux!=0)
               {
                  int OrderBuy = OrderSend(Symbol(),OP_BUY,myLotAux,BuyPrice,slippage,sl,tp,text,Magic,0,Blue);
                  //Reservo el valor del tamao del lote anterior completo para cuando tenga que
                  //fraccionar una orden en no ms de MaxLots  50.
                  //Esto tiene que estar dentro del if de "pierde PipsStep". De lo contrario myLotsi
                  //se recalcula con cada pip.
                  if(OrderBuy>=0) LastLotSize = lotsi; //Si no fall el ingreso de la orden
               }
               
               if((lotsi/MaxLots)>=1)
		         {
		             cnt2 = NormalizeDouble((lotsi/MaxLots),2)-NormalizeDouble((myLotAux/MaxLots),2);
		             if(cnt2<1) {cnt2=1;}
		             for(cnt=cnt2;cnt>0 ;cnt--)
		             {
		               int OrderBuyAux = OrderSend(Symbol(),OP_BUY,MaxLots,BuyPrice,slippage,sl,tp,text,Magic,0,Blue);
		               if(OrderBuyAux>=0) MaxTradesAux++;//Si no fall el ingreso de la orden fraccionada
		             }
		         }
		         
		         if(OrderBuy>=0 && _ExpertOrdersTotal>0 && TrailingProfit==true)
               {
                  ChangeTP(tp,PreviousOpenOrders);
               }
		         
		         if(myLotAux==0 && lotsi==MaxLots) { MaxTradesAux--;}
		         Print("Ticket OrderBuy :",DoubleToStr(OrderBuy,2));
            }
            break;
   
         //SELL
         case 1:
            //Ingresa nuevas ordenes si no hay abiertas o la ltima pierde PipsStep
            if(_ExpertOrdersTotal<1 ||(Bid-_OrderOpenPrice[0])>=PipsStepAux*Point)
            {
               SellPrice=NormalizeDouble(Bid,Digits);
               if(_ExpertOrdersTotal>0) tp=_OrderOpenPrice[0]-(TakeProfit-PipsStep)*Point;
               else tp = Bid-TakeProfit*Point;
               sl = 0;
         
               myLotAux = NormalizeDouble(MathMod(lotsi,MaxLots),2);
		    
               if(myLotAux!=0)
               {
                  int OrderSell = OrderSend(Symbol(),OP_SELL,myLotAux,SellPrice,slippage,sl,tp,text,Magic,0,Red);		    		    
                  if(OrderSell>=0) LastLotSize = lotsi; 
               }
       
               if((lotsi/MaxLots)>=1)
		         {
		             cnt2 = NormalizeDouble((lotsi/MaxLots),2)-NormalizeDouble((myLotAux/MaxLots),2);
		             if(cnt2<1) {cnt2=1;}
		             for(cnt=cnt2;cnt>0 ;cnt--)
		             {
                     int OrderSellAux = OrderSend(Symbol(),OP_SELL,MaxLots,SellPrice,slippage,sl,tp,text,Magic,0,Red);
                     if(OrderSellAux>=0) MaxTradesAux++; 
                   }
               }
               
               if(OrderSell>=0 && _ExpertOrdersTotal>0 && TrailingProfit==true)
               {
                  ChangeTP(tp,PreviousOpenOrders);
               }
         
               //Esto sirve para evitar un conteo erroneo de la cantidad de ordenes ingresadas
               //cuando el tamao del lote de una orden es exactamente igual a MaxLots  50.
               if(myLotAux==0 && lotsi==MaxLots) { MaxTradesAux--;}
               Print("Ticket OrderSell:",DoubleToStr(OrderSell,2));
            
               //if(OrderSell<0 ||OrderSellAux<0) { return;}        
            }
            break;
      }//Fin switch myOrderType
      
      //Si lleg el puntero hasta ac Margin>0 & ninguna orden toc TP.
      //Esto hay que asignarlo ni bien se ingresa una orden nueva. Ver caso 04/01/07 EURJPY.
      //En un tic se produjo una entrada buy y al siguiente, dio un salto tan alto que se cerr,
      //pero como el EA actualizaba al inicio de un nuevo tic no tenia actualizado la cantidad
      //de ordenes abiertas.
      AllOrdersInit(Magic);
      PreviousOpenOrders=_ExpertOrdersTotal;
      
    } //Fin ContinueOpening
   
//----
   //text = " Magic :"+DoubleToStr(Magic,0)+"Ordenes Abiertas: "+_ExpertOrdersTotal+
   //" / Floating P/L: "+DoubleToStr(_ExpertProfitTotal,2);
   //if(StopTrading==true)
   //{
   //   text = text+" - EA SE DETENDRA CUANDO CIERRE MARTINGALA ABIERTA.";
   //}
   //Comment(text);
   
   string text1 = "Magic :"+DoubleToStr(Magic,0)+" Floating P/L: "+DoubleToStr(_ExpertProfitTotal,2);
   string text2 = "Ordenes Abiertas: "+DoubleToStr(_ExpertOrdersTotal,0)+
   " Last Lot Size : "+DoubleToStr(LastLotSize,2);
   string text3 =  "Account Balance :"+DoubleToStr(AccountBalance(),2);
   
   if(StopTrading==true) { string text4 = "EA SE DETENDRA CUANDO CIERRE MARTINGALA ABIERTA";}
   else text4="Account Equity :"+DoubleToStr(AccountEquity(),2);
   
   string text5 = "Free Margin :"+DoubleToStr(AccountFreeMargin(),2);
   
   if(_ExpertOrdersTotal>0)
   {
      if(AccountFreeMarginCheck(Symbol(),myOrderType,lotsi)<=0)
      {
         text5 = text5+ " Margen insuficiente para prxima orden." ;
      }
   }
   
   info( 0, text1, Lime, 8 );
	info( 1, text2, Aquamarine );
	info( 2, text3, Aquamarine );
	info( 3, text4, Aquamarine );
	info( 4, text5, Aquamarine );  


//----
   return(0);
  }
//----------------------------  
  

//Funcin que cierra todas las ordenes abiertas.  
void CierraTodo()
{
//----
   for(int h=OrdersTotal() ; h>=0; h--)
	{
	  OrderSelect(h, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	  {
	     for(int i = 1 ; i <= NumberOfTries; i++)
	     {
	        bool TicketClosed = OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),slippage,Yellow);
	        
	        if(!TicketClosed)
   	     {
   	        error = GetLastError(); 
		        Print("Error :",error," cerrando orden: ",OrderTicket(),
		        ". Reintento :",i,"/",NumberOfTries);
		        Sleep(5000); //5 segundos
		     }
		     else   break;
	     } //end for i
	        
	     if(!TicketClosed)
   	  {
   	     int error = GetLastError();
		     Print("No se pudo cerrar orden: ",OrderTicket()," Error: ",error," ",ErrorDescription(error));
		  }
	  }
	} //end for h
//----
   return;
} 


//+----------------------------------------------------------------------
//Modifies take profit of opened orders to ensure exact and simultaneous close of all the
//martingale. It also avoids problems on internet connection, because take profit is placed
//on broker server.
void ChangeTP(double TP, int OrderOfThisMartingale)
{
    
   for(int h=0; h<OrdersTotal()-1; h++)
   {

      OrderSelect(h, SELECT_BY_POS, MODE_TRADES);
      
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == Magic) 
	   {
	        //This avoid change TP on the last/s order/s martingale serie when its lot size
	        //is bigger than 50.    
	        if(OrderOfThisMartingale <= 0)
	        { break; }
	    
	        OrderOfThisMartingale--;
	           
	        for(int i = 1 ; i <= NumberOfTries; i++)
	        {
	           bool TicketModify = OrderModify(OrderTicket(),0,0,TP,0,Lime);
	        
	           if(!TicketModify)
   	        {
   	           error = GetLastError(); 
		           Print("Error :",error," modificando orden: ",OrderTicket(),
		           ". Reintento :",i,"/",NumberOfTries);
		           Sleep(5000); //5 segundos
		        }
		        else   break;
	        } //end for i
	        
	        if(!TicketModify) { Print("No se pudo modificar orden :",OrderTicket()); }
	    }
      
   
   } //end for h


//----
   return;
}

//+------------------------------------------------------------------+